DECLARE SUB INITIALIZE (ISC&, DVM&, SOURCE&)
DECLARE SUB SOURCESETUP (SOURCE&)
DECLARE SUB DVMSETUP (DVM&)
DECLARE SUB TRIGGER (DVM&, SOURCE&)
DECLARE SUB WAITFORSRQ (ISC&, DVM&)
DECLARE SUB TAKEREADINGS (ISC&, DVM&, MAX.READINGS%, ACT.ELEMENTS%)
DECLARE SUB PRINTREADINGS (ACTUAL%)
'
' Copyright Hewlett-Packard Co., 1986, 1989
'

REM $INCLUDE: 'QBSETUP'

OPTION BASE 1
MAX.ELEMENTS% = 20
DIM READINGS!(20)
ACT.ELEMENTS% = 0
CALL INITIALIZE(ISC&, DVM&, SOURCE&)
CALL SOURCESETUP(SOURCE&)
CALL DVMSETUP(DVM&)
CALL TRIGGER(DVM&, SOURCE&)
CALL WAITFORSRQ(ISC&, DVM&)
CALL TAKEREADINGS(ISC&, DVM&, MAX.READINGS%, ACT.ELEMENTS%)
CALL PRINTREADINGS(ACT.ELEMENTS%)
END

SUB DVMSETUP (DVM&) STATIC
SHARED PCIB.ERR, PCIB.BASERR, NOERR

  CODES$ = "H SM004 F2 R4 FL0 Z0 4STG 20STN RS1 T4"
  CALL IOOUTPUTS(DVM&, CODES$, LEN(CODES$))
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
END SUB

SUB INITIALIZE (ISC&, DVM&, SOURCE&) STATIC
SHARED PCIB.ERR, PCIB.BASERR, NOERR

  INPUT "Enter Select Code: ", ISC&
  PRINT
  INPUT "Enter bus address of VOLTMETER: ", DVM&
  DVM& = ISC& * 100 + DVM&
  PRINT
  INPUT "Enter bus address of SOURCE: ", SOURCE&
  SOURCE& = ISC& * 100 + SOURCE&
  PRINT
  CALL IORESET(ISC&)
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
  CALL IOTIMEOUT(ISC&, 5!)
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
  CALL IOCLEAR(ISC&)
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
END SUB

SUB PRINTREADINGS (ACTUAL%) STATIC
SHARED READINGS!()

  PRINT "THE READINGS ARE: "
  FOR I% = 1 TO ACTUAL%
    PRINT I%, READINGS!(I%)
  NEXT I%
END SUB

SUB SOURCESETUP (SOURCE&) STATIC
SHARED PCIB.ERR, PCIB.BASERR, NOERR

  CODES$ = "RF2 FU1 ST1KH SP10KH MF1KH AM2VR TI5SE"
  CALL IOOUTPUTS(SOURCE&, CODES$, LEN(CODES$))
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
END SUB

SUB TAKEREADINGS (ISC&, DVM&, MAX.READINGS%, ACT.ELEMENTS%) STATIC
SHARED PCIB.ERR, PCIB.BASERR, NOERR, READINGS!()

  CODES$ = "SO1 -20STR RER"
  LENGTH% = LEN(CODES$)
  CALL IOOUTPUTS(DVM&, CODES$, LENGTH%)
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
  '
  STATE% = 0
  CALL IOEOI(ISC&, STATE%)
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
  CALL IOENTERA(DVM&, SEG READINGS!(1), MAX.ELEMENTS%, ACT.ELEMENTS%)
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
END SUB

SUB TRIGGER (DVM&, SOURCE&) STATIC
SHARED PCIB.ERR, PCIB.BASERR, NOERR

  CALL IOTRIGGER(DVM&)
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
  CODES$ = "SS"
  CALL IOOUTPUTS(SOURCE&, CODES$, LEN(CODES$))
  IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
END SUB

SUB WAITFORSRQ (ISC&, DVM&) STATIC
SHARED PCIB.ERR, PCIB.BASERR, NOERR

	   SRQ% = 1
CHECKSTAT: CALL IOSTATUS(ISC&, SRQ%, STATUS%)
	   IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
	   IF STATUS% = 0 THEN GOTO CHECKSTAT
	   CALL IOSPOLL(DVM&, RESPONSE%)
	   IF PCIB.ERR <> NOERR THEN ERROR PCIB.BASERR
	   IF (RESPONSE% AND 68) <> 68 THEN GOTO CHECKSTAT
END SUB
